<?php
//    MyDMS. Document Management System
//    Copyright (C) 2002-2005  Markus Westphal
//    Copyright (C) 2006-2008 Malcolm Cowe
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

include("../inc/inc.Settings.php");
include("../inc/inc.AccessUtils.php");
include("../inc/inc.ClassAccess.php");
include("../inc/inc.ClassDocument.php");
include("../inc/inc.ClassFolder.php");
include("../inc/inc.ClassGroup.php");
include("../inc/inc.ClassUser.php");
include("../inc/inc.DBAccess.php");
include("../inc/inc.FileUtils.php");
include("../inc/inc.Language.php");
include("../inc/inc.ClassUI.php");
include("../inc/inc.ClassEmail.php");
include("../inc/inc.Authentication.php");

if (!isset($_POST["folderid"]) || !is_numeric($_POST["folderid"]) || intval($_POST["folderid"])<1) {
	UI::htmlStartPage(getMLText("folder_title", array("foldername" => getMLText("invalid_folder_id"))));
	UI::globalNavigation();
	UI::pageNavigation(getMLText("invalid_folder_id"));
	UI::htmlEndPage();
	exit;
}
$folderid = $_POST["folderid"];
$folder = getFolder($folderid);
if (!is_object($folder)) {
	UI::htmlStartPage(getMLText("folder_title", array("foldername" => getMLText("invalid_folder_id"))));
	UI::globalNavigation();
	UI::pageNavigation(getMLText("invalid_folder_id"));
	UI::htmlEndPage();
	exit;
}

UI::htmlStartPage(getMLText("folder_title", array("foldername" => $folder->getName())));
UI::globalNavigation($folder);
$folderPathHTML = getFolderPathHTML($folder, true);

if ($folder->getAccessMode($user) < M_READWRITE) {
	UI::pageNavigation($folderPathHTML, "view_folder", $folder);
	UI::contentHeading(getMLText("add_subfolder"));
	UI::contentContainer(getMLText("operation_not_allowed"));
	UI::htmlEndPage();
	exit;
}

$sequence = $_POST["sequence"];
if (!is_numeric($sequence)) {
	UI::pageNavigation($folderPathHTML, "view_folder", $folder);
	UI::contentHeading(getMLText("add_subfolder"));
	UI::contentContainerStart();
	printMLText("adding_sub_folder", array("subfoldername" => $name, "foldername" => $folder->getName()));
	printMLText("invalid_sequence");
	UI::contentContainerEnd();
	UI::htmlEndPage();
	exit;
}

$name = sanitizeString($_POST["name"]);
$comment = sanitizeString($_POST["comment"]);
$subFolder = $folder->addSubFolder($name, $comment, $user, $sequence);
	
if (is_object($subFolder)) {
	$folderPathHTML = getFolderPathHTML($subFolder, true);
	UI::pageNavigation($folderPathHTML, "view_folder", $subFolder);
	UI::contentHeading(getMLText("add_subfolder"));
	UI::contentContainerStart();
	printMLText("adding_sub_folder", array("subfoldername" => $name, "foldername" => $folder->getName()));
	printMLText("op_finished");
}
else {
	UI::pageNavigation($folderPathHTML, "view_folder", $folder);
	UI::contentHeading(getMLText("add_subfolder"));
	UI::contentContainerStart();
	printMLText("adding_sub_folder", array("subfoldername" => $name, "foldername" => $folder->getName()));
	printMLText("error_occured");
}

UI::contentContainerEnd();
UI::htmlEndPage();
?>
